<template>
  <rui-loading v-if="loading" text="Loading example..." />
  <rui-alert v-else-if="error" variant="danger">{{ error }}</rui-alert>

  <doc-example-wrapper>
    <component :is="exampleComponent" v-if="fileType==='vue' && exampleComponent" />
    <doc-v-html v-else-if="fileType === 'html' && source" :html="source" />
  </doc-example-wrapper>

  <template v-if="source">
    <h3>Source</h3>
    <doc-code-block-renderer language="xml">{{ source }}</doc-code-block-renderer>
  </template>
</template>

<script>
import { defineAsyncComponent, markRaw } from 'vue'
import { RuiAlert, RuiLoading } from '../../../src/components/index.js'
import DocExampleWrapper from '../ExampleWrapper/ExampleWrapper.vue'
import DocCodeBlockRenderer from '../CodeBlockRenderer/CodeBlockRenderer.vue'
import DocVHtml from '../VHtml/VHtml.js'

/**
 * This component is responsible for displaying an example : a rendered component and its source.
 *
 * It handles Vue and HTML files.
 */
export default {
  name: 'DocExampleRenderer',
  components: { DocVHtml, DocExampleWrapper, RuiLoading, RuiAlert, DocCodeBlockRenderer },
  props: {
    /** Example path, without the extension, and relative to the `examples` directory */
    file: { required: true, type: String },
    /** Example extension */
    fileType: { required: true, type: String, validate: (v) => (['vue', 'html'].includes(v)) },
  },
  data () {
    return {
      loading: false,
      error: null,
      // Data
      exampleComponent: null,
      source: null,
      componentName: this.file.split('/')[0],
    }
  },
  created () {
    this.loading = true
    let source

    if (this.fileType === 'vue') {
      source = this.$loadVueExampleSource(this.file)
      this.exampleComponent = markRaw(defineAsyncComponent(() => this.$loadVueExample(this.file)))
    } else {
      source = this.$loadHTMLExample(this.file)
      this.exampleComponent = 'v-html'
    }

    source
      .then((r) => { this.source = r.default })
      .catch((err) => { this.error = `Error loading example: ${this.file}: ${err}` })
      .then(() => { this.loading = false })
  },
}
</script>
